#include <stdio.h>
#include "forms.h"
#include "tyman.h"

FD_dialog *fd_dialog;
char * icon_place;
int action;
#ifndef ICON_DIR
#define ICON_DIR /usr/include/X11/pixmaps
#endif
#define ADD_ICON 0
#define EDIT_ICON 1
char X[10];
char Y[10];
char ICON[1024];
char NAME[1024];
char COMMAND[1024];
char DROP_CMD[1024];
char *title;
char *tyopt;
usage(char * name)
{
  fprintf(stderr,"Usage: %s -add|-edit [IconDir]\n",name);
  exit(1);
}

int main(int argc, char *argv[])
{
  FL_IOPT flopt;

  char * junk, * str;
  int k,i;
  char line[1024];
  int  WasActive=0;
  FILE * iconrc;
  char ini_file[1024];
  char stdline[1024];
  char coords[1024];
  char label[1024];
  char label_ench[1028];
  char xpm[1024];
  char command[1024];
  char drop_command[1024];
  unsigned int x,y;

  flopt.debug=0;
  flopt.borderWidth=-2;


  fl_set_defaults(FL_PDDebug| FL_PDBorderWidth/*|FL_PDButtonLabelSize*/,
		  &flopt);
#if FL_REVISION>=80
   fl_initialize(&argc, argv, "TycoonManager", 0, 0);
#else
   fl_initialize(argv[0], "TycoonManager", 0, 0, &argc, argv);
#endif

  fl_show_errors(0);
  fl_set_goodies_font(FL_NORMAL_STYLE,14);

  if (!(argc==2 || argc==3)) usage(argv[0]);

  if (strcmp(argv[1],"-add")!=0 && strcmp(argv[1],"-edit")!=0) usage(argv[0]);
  if  (strcmp(argv[1],"-add")==0) 
    {
      action=ADD_ICON;
      title="Add new icon";
      tyopt="-add";
    }
  else 
    {
      title="Edit icon properties";
      action=EDIT_ICON;
      tyopt="-edit";
    }
  if (argc==2) icon_place=ICON_DIR;
  if (argc==3) icon_place=argv[2];

  if (action==EDIT_ICON)
    {
      strcpy(ini_file, getenv("HOME"));
      strcat(ini_file, "/.tycoon");
      if ((iconrc=fopen(ini_file,"r")) == NULL)
	{
	  perror ("open ini-file");
	  return -1;
	}
      
      while (!feof(iconrc))
	{
	  fgets(stdline,1024,iconrc);
	  stdline[strlen(stdline)-1] = 0; /* strip \n */
	  if (feof(iconrc)) goto Accc;
	  if (strncasecmp(stdline,"[Freezed]",strlen("[Freezed]"))==0)
	    {
	    }
	  if (strncasecmp(stdline,"[Icon]",strlen("[Icon]"))==0 ||
	      strncasecmp(stdline,"[Active]",strlen("[Active]"))==0)
	    {
	      if ( strncasecmp(stdline,"[Active]",strlen("[Active]"))==0)
		{WasActive=1;}
	      fgets(coords,1024,iconrc);
	      if (feof(iconrc)) 
		{
		  fprintf(stderr,"Syntax error in [Icon] section");
		  exit(-1);
		}
	      x=-1;y=-1;
	      sscanf(coords,"%i %i",&x,&y);
	      sprintf(X,"%i",x);
	      sprintf(Y,"%i",y);
	      fgets(label,1024,iconrc);
	      label[strlen(label)-1] = 0; /* strip \n */
	      for (i=0;i<1024;i++) NAME[i]=0; /* No fucking bzero on some U*x */
	      for (i=0,k=0;label[i]!=0;i++,k++)
		{
		  NAME[k]=label[i];
		  if (label[i]=='\\' && 
		      label[i+1]=='n') /* \n sequence */
		    {
		      NAME[k]='\n';
		      i++;
		    }
		}
	      
	      if (feof(iconrc))
		{
		  fprintf(stderr,"Syntax error in [Icon] section");
		  exit(-1);
		}
	      fgets(xpm,1024,iconrc);
	      xpm[strlen(xpm)-1] = 0; /* strip \n */
	      strcpy(ICON,xpm);
	      if (feof(iconrc)) 
		{
		  fprintf(stderr,"Syntax error in [Icon] section");
		  exit(-1);
		}
	      fgets(command,1024,iconrc);
	      command[strlen(command)-1] = 0; /* strip \n */
	      strcpy(COMMAND,command);
	      if (feof(iconrc)) 
		{
		  fprintf(stderr,"Syntax error in [Icon] section");
		  exit(-1);
		}
	      fgets(drop_command,1024,iconrc);
	      drop_command[strlen(drop_command)-1] = 0; /* strip \n */
	      strcpy(DROP_CMD,drop_command);
	      if (WasActive) goto Accc;
	    }
	}
    Accc:
      
      fclose(iconrc);
      if (!WasActive)
	{
	  fl_show_alert("Please select some icon",NULL,NULL,1);
	  exit(0);
	}
    }
  fd_dialog = create_form_dialog();
  
   /* show the first form */


   XWarpPointer(fl_get_display(),None,
		fl_show_form(fd_dialog->dialog,FL_PLACE_CENTER,
		FL_FULLBORDER,
		title),
		0,0,0,0,120,70);
   fl_do_forms();
   return 0;
}
